/*
 * Copyright (C) 2018 The Dagger Authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package dagger.functional.componentdependency;

import dagger.Component;
import dagger.Module;
import dagger.Provides;
import javax.inject.Provider;

interface BoxedPrimitives {
  interface Dependency {
    int primitive();
  }

  @Component(dependencies = Dependency.class)
  interface ConsumesPrimitiveThroughDependency {
    Provider<Integer> providerOfBoxedPrimitive();
  }

  @Module
  class PrimitiveModule {
    @Provides
    static int providePrimitive() {
      return 1;
    }
  }

  @Component(modules = PrimitiveModule.class)
  interface ConsumesPrimitiveFromProvidesMethod {
    Provider<Integer> providerOfBoxedPrimitive();
  }

}
